// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

// Class for generating the spectral CKD

#pragma once

#include "processor.h"

namespace spex {

class WaveGen : public Processor
{
public:
    WaveGen(const SPEXSettings& settings, CKD& ckd)
      : Processor { settings, ProcLevel::wave, ckd }
    {}
    ~WaveGen() = default;

protected:
    auto processInit() -> void override;
    // Distribute L1A products into batches by viewports
    auto prepareBatches() -> void override;
    auto processBatch(const int i_vp) -> void override;
    // Define a common wavelength grid for co-sampling S+ and S-
    auto processFinalize() -> void override;
};

} // namespace spex
